﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Malovani
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();
            int W = pictureBox.Width;
            int H = pictureBox.Height;
            Bitmap b = new Bitmap(W, H);
            Graphics g = Graphics.FromImage(b);
            g.FillRectangle(Brushes.White, 0, 0, W - 1, H - 1);
            pictureBox.Image = b;
        }

        private int X0, Y0;
        private bool stisknuto = false;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisknuto = true;
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                int X1 = e.X;
                int Y1 = e.Y;

                int W = Math.Abs (X1 - X0);
                int H = Math.Abs (Y1 - Y0);

                int X = X0 < X1 ? X0 : X1;
                int Y = Math.Min(Y0, Y1);

                // Brush b = new SolidBrush(color);

                // using System.Drawing.Drawing2D;
                Brush b = new LinearGradientBrush
                          (new Point(X,Y),
                           new Point(X+W-1, Y+H-1),
                           color,
                           color2);

                Pen p = new Pen(penColor);
                p.Width = 5;

                Graphics g = Graphics.FromImage(pictureBox.Image);

                // g.FillRectangle(b, X, Y, W, H);
                // g.DrawRectangle(p, X, Y, W, H);
                g.FillEllipse(b, X, Y, W, H);
                g.DrawEllipse(p, X, Y, W, H);
                
                pictureBox.Invalidate();
            }
        }

        private Color color = Color.Yellow;
        private Color color2 = Color.Red;
        private Color penColor = Color.Blue;

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            Control p = (Control) sender;
            // Control p = sender as Control;
            if (e.Button == MouseButtons.Left)
                color = p.BackColor;
            else if (e.Button == MouseButtons.Middle)
                color2 = p.BackColor;
            else if (e.Button == MouseButtons.Right)
                penColor = p.BackColor;
        }

        private void panel1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            Control p = (Control)sender;
            colorDialog.Color = p.BackColor;
            if (colorDialog.ShowDialog() == DialogResult.OK)      
            {
               p.BackColor = colorDialog.Color;
               color = p.BackColor;
            }
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog() == DialogResult.OK)
            {
                Bitmap b = new Bitmap(openDialog.FileName);
                pictureBox.Image = b;
            }
        }
    }
}
